# ----------------------------------------------------------------------------
# "THE BEER-WARE LICENSE" (Revision 42):
# <phk@FreeBSD.ORG> wrote this file.  As long as you retain this notice you
# can do whatever you want with this stuff. If we meet some day, and you think
# this stuff is worth it, you can buy me a beer in return.   Poul-Henning Kamp
# ----------------------------------------------------------------------------
# $Id: pic18.ck,v 1.96 2008/02/16 16:27:39 phk Exp $

INSTANCE pic18 UINT {
	name	cfg_pic18
	desc	"pic18 microcontroller"
	new	cfg_pic18_new
	destroy	cfg_pic18_destroy

	INSTANCE pin UINT {
		desc 	"pin configuration"
		head	cfg_pic18_pin_head
		new	cfg_pic18_pin_new
		destroy	cfg_pic18_pin_destroy

		WORD type ENUM {off din dout ain counter temp pullup} {
			desc	"type of pin"
			func	cfg_pic18_pin_type
		}
	}

	WORD pollrate UINT {
		desc	"Poll rate"
		func	cfg_pic18_pollrate
	}
	WORD vref REAL {
		desc	"Analog Reference voltage"
		func	cfg_pic18_vref
	}
	WORD tempres UINT {
		desc	"Temperature Resolution"
		func	cfg_pic18_tempres
	}
	WORD adcon2 UINT {
		desc	"ADCON2 register value"
		func	cfg_pic18_adcon2
	}
	WORD averaging UINT {
		desc	"Averaging/Oversampling factor"
		func	cfg_pic18_averaging
	}
	WORD serial WORD ... {
		desc	"serial port device name"
		func	cfg_pic18_serial
	}
	WORD point WORD ... {
		desc	"point configuration"
		func	cfg_pic18_point
	}
	WORD debug UINT {
		desc	"Debug configuration"
		func	cfg_pic18_debug
	}
}
