# ----------------------------------------------------------------------------
# "THE BEER-WARE LICENSE" (Revision 42):
# <phk@FreeBSD.ORG> wrote this file.  As long as you retain this notice you
# can do whatever you want with this stuff. If we meet some day, and you think
# this stuff is worth it, you can buy me a beer in return.   Poul-Henning Kamp
# ----------------------------------------------------------------------------
# $Id: pic18m.ck,v 1.102 2008/04/29 20:46:27 phk Exp $

INSTANCE pic18m UINT {
	name	cfg_pic18m
	desc	"pic18 microcontroller"
	new	cfg_pic18m_new
	destroy	cfg_pic18m_destroy

	INSTANCE pin UINT {
		desc 	"pin configuration"
		head	cfg_pic18m_pin_head
		new	cfg_pic18m_pin_new
		destroy	cfg_pic18m_pin_destroy

		WORD type ENUM {off adc din dout ain counter temp pullup aout} {
			desc	"type of pin"
			func	cfg_pic18m_pin_type
		}
	}

	INSTANCE param WORD {
		desc	"parameter configuration"
		head	cfg_pic18m_param_head
		new	cfg_pic18m_param_new
		destroy	cfg_pic18m_param_destroy

		WORD val WORD  {
			desc	"value of param"
			func	cfg_pic18m_param_val
		}
	}

	WORD pollrate UINT {
		desc	"Poll rate"
		func	cfg_pic18m_pollrate
	}
	WORD vref REAL {
		desc	"Analog Reference voltage"
		func	cfg_pic18m_vref
	}
	WORD tempres UINT {
		desc	"Temperature Resolution"
		func	cfg_pic18m_tempres
	}
	WORD adcon2 UINT {
		desc	"ADCON2 register value"
		func	cfg_pic18m_adcon2
	}
	WORD averaging UINT {
		desc	"Averaging/Oversampling factor"
		func	cfg_pic18m_averaging
	}
	WORD serial WORD ... {
		desc	"serial port device name"
		func	cfg_pic18m_serial
	}
	WORD multicast UINT {
		desc	"multicast identifier"
		func	cfg_pic18m_multicast
	}
	WORD point WORD ... {
		desc	"point configuration"
		func	cfg_pic18m_point
	}
	WORD debug UINT {
		desc	"Debug configuration"
		func	cfg_pic18m_debug
	}
}
