/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <phk@FreeBSD.ORG> wrote this file.  As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return.   Poul-Henning Kamp
 * ----------------------------------------------------------------------------
 * $Id: load.c,v 1.4 2008/03/19 11:04:19 phk Exp $
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <configkit.h>
#include <dlfcn.h>

#include "measured.h"
#include "measured_int.h"
#include "configkit_conf.h"

int
load_func(CK_ARG, char **arg)
{
	void *dlhandle;
	char *p;

	if (cfa->flag & (CK_SHOW|CK_CONF|CK_NO))
		return (0);


	assert(arg != NULL);
	if (arg[0] == NULL) {
		ck_printf(CK_PASS, "missing argument: module name to load\n");
		return (1);
	}
	if (arg[1] == NULL)
		asprintf(&p,
		    "/usr/local/libexec/measured_modules/measured_%s.so",
		    arg[0]);
	else 
		asprintf(&p, "%s/measured_%s.so", arg[1], arg[0]);
	assert(p != NULL);

	dlhandle = dlopen(p, RTLD_NOW | RTLD_LOCAL);
	if (dlhandle == NULL) {
		ck_printf(CK_PASS, "load failed, dlopen(%s): %s\n",
		    p, dlerror());
		free(p);
		return (1);
	}
	free(p);
	return (0);
}

void
module_ctor(void *np)
{
	ck_TreeAdd(cft, np);
}
