/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <phk@FreeBSD.ORG> wrote this file.  As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return.   Poul-Henning Kamp
 * ----------------------------------------------------------------------------
 * $Id: measured_api.h,v 1.3 2007/09/05 13:15:10 phk Exp $
 *
 */


enum point_type {
	UNDEF		= 1,
	AIN		= 3,
	DIN		= 4,
	AOUT		= 5,
	DOUT		= 6,
	COUNT		= 7
};

/* XXX: MIB mirrors these values */
enum limit_e {
	L_LOW		= 0,
	L_SAG		= 1,
	L_RAISE		= 2,
	L_HIGH		= 3,
	L_NORMAL	= 4,
	L_TIMEOUT	= 5,
	L_CHANGED	= 6,
	L_INVALID	= 10
};

/* XXX: MIB mirrors these values */
enum statepri_e {
	SP_UNKNOWN	= 0,
	SP_FAILED	= 1,
	SP_MAJOR	= 2,
	SP_MINOR	= 3,
	SP_OK		= 5
};
 
/* Utils -------------------------------------------------------------*/

int ParseInstance(const char *p, unsigned *instance);
const char *PointType(enum point_type);
enum point_type TypePoint(const char *pp);
enum limit_e TypeLimit(const char *pp);
const char *LimitType(enum limit_e e);

typedef int (lineup_f)(void *, const char *);
struct lineup *NewLineup(void *priv, lineup_f *func);
int LineUpFd(int fd, struct lineup *l);
int LineUpFile(FILE *f, struct lineup *l);
void DestroyLineup(struct lineup *l);
int fdprintf(int fd, const char *format, ...);


#define POINT_MASK	((1U << 10U) - 1U)
#define GROUP_MASK	(POINT_MASK << 10)
#define SITE_MASK	(GROUP_MASK << 10)

#define POINT_SHIFT	0
#define GROUP_SHIFT	10
#define SITE_SHIFT	20

#define SITE_OF(foo)	(((foo) & SITE_MASK) >> SITE_SHIFT)
#define GROUP_OF(foo)	(((foo) & GROUP_MASK) >> GROUP_SHIFT)
#define POINT_OF(foo)	((foo) & POINT_MASK)

#define MAX_TRAP		200
