# ----------------------------------------------------------------------------
# "THE BEER-WARE LICENSE" (Revision 42):
# <phk@FreeBSD.ORG> wrote this file.  As long as you retain this notice you
# can do whatever you want with this stuff. If we meet some day, and you think
# this stuff is worth it, you can buy me a beer in return.   Poul-Henning Kamp
# ----------------------------------------------------------------------------
# $Id: measured_conf.ck,v 1.100 2008/04/29 19:45:14 phk Exp $

NODE point {
	name	cfg_point
	desc	"per point stuff"

	WORD label WORD {
		desc	"Alphanumeric label"
		func	cfg_point_label
	}
	WORD format WORD {
		desc	"Format string"
		func	cfg_point_format
	}
	WORD unit WORD {
		desc	"Measurement units"
		func	cfg_point_unit
	}
	WORD offset WORD {
		desc	"Offset value"
		func	cfg_point_offset
	}
	WORD hysteresis WORD {
		desc	"Limit hysteresis"
		func	cfg_point_hysteresis
	}
	WORD limitdelay REAL {
		desc	"Delay before limit alarm"
		func	cfg_point_limitdelay
	}
	WORD scale WORD {
		desc	"Scaling factor"
		func	cfg_point_scale
	}
	WORD low WORD {
		desc	"Low alarm limit"
		func	cfg_point_low
	}
	WORD sag WORD {
		desc	"Sag alarm limit"
		func	cfg_point_sag
	}
	WORD raise WORD {
		desc	"Raise alarm limit"
		func	cfg_point_raise
	}
	WORD high WORD {
		desc	"High alarm limit"
		func	cfg_point_high
	}
	WORD change WORD {
		desc	"Change alarm"
		func	cfg_point_change
	}
	WORD timeout WORD {
		desc	"Timeout"
		func	cfg_point_timeout
	}
	WORD trap UINT {
		desc	"SNMP Trap number (obsolete)"
		func	cfg_point_trap
	}
	WORD state UINT ENUM {failed major minor} {
		desc	"SNMP State and priority"
		func	cfg_point_state
	}
}

WORD all ... {
	name	cfg_all
	desc	"Show all measurements"
	func	show_all
}

INSTANCE slave UINT {
	name	cfg_slave
	desc	"Remote sites"
	new	cfg_slave_new
	destroy	cfg_slave_destroy

	WORD hostname WORD {
		desc	"Hostname or IP number"
		func	cfg_slave_hostname
	}

	WORD port WORD {
		desc	"TCP/IP port number"
		func	cfg_slave_port
	}
	WORD timeout REAL {
		desc	"TCP RCVTIMEO"
		func	cfg_slave_timeout
	}
	WORD retry REAL {
		desc	"Pause between connection retries"
		func	cfg_slave_retry
	}
}

INSTANCE modbus UINT {
	name	cfg_modbus
	new	cfg_modbus_new
	destroy	cfg_modbus_destroy
	desc	"MODBUS interfaces"

	WORD serial WORD ... {
		desc	"serial port device name or host:port"
		func	cfg_modbus_serial
	}
	WORD point WORD ... {
		desc	"point configuration"
		func	cfg_modbus_point
	}
	WORD rts UINT {
		desc	"Use RTS for direction control"
		func	cfg_modbus_rts
	}
	WORD dtr UINT {
		desc	"Use DTR for direction control"
		func	cfg_modbus_dtr
	}
	WORD delay UINT {
		desc	"Modem control delay [usec]"
		func	cfg_modbus_delay
	}
	WORD debug UINT {
		desc	"Debug configuration"
		func	cfg_modbus_debug
	}
	WORD rate UINT {
		desc	"Poll rate"
		func	cfg_modbus_rate
	}
}

NODE auth {
	name	cfg_auth
	desc	"Authentication data"

	WORD realm WORD {
		desc	"Realm for password prompt"
		func	cfg_auth_realm
	}

	WORD timeout UINT {
		desc	"Session key timeout"
		func	cfg_auth_timeout
	}

	WORD debug UINT {
		desc	"debug level"
		func	cfg_auth_debug
	}

	INSTANCE user WORD {
		new	cfg_auth_user_new
		head	cfg_auth_user_head
		destroy	cfg_auth_user_destroy
		desc	"User registration"

		WORD password WORD {
			desc "Users password"
			func cfg_auth_user_password
		}
	}
}

INSTANCE state UINT {
	name	cfg_state
	new	cfg_state_new
	destroy	cfg_state_destroy
	desc	"State indicators"

	WORD string WORD {
		desc	"String message"
		func	cfg_state_string
	}
}

WORD load ... {
	name	cfg_load
	desc	"load module"
	func	load_func
}
